# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
from __future__ import with_statement
import es, gamethread, os, random
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func    = es.import_addon('sam/functions')
monitor = es.import_addon('sam/core/monitor')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x # VARIABLES/DICTIONARIES/LISTS # xx #
path = 'cstrike/cfg/sam_config/adverts.txt'
temp = {'last':'None','delay':30,'addonsMSGs':[],'logmsgs':False,'tag':True}
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# CREATE CFG
	createFile()

	# CMD
	func.ServerCMD('sam_adverts_delay', delayCMD)
	func.ServerCMD('sam_adverts_on_console', logCMD)
	func.ServerCMD('sam_adverts_tag', tagCMD)

	# CFG
	lib = {'sam_adverts_delay':{'value':temp['delay'],'description':'Delay in seconds between each advert message.'},
		   'sam_adverts_on_console':{'value':0,'description':'Whether or not to also display each advert on the servers console.'},
		   'sam_adverts_tag':{'value':1,'description':'Whether or not SAM Chat Tag is on each advert message.'}}
	monitor.cfg('adverts', lib)

	# START LOOP
	gamethread.delayedname(1, 'sam_adverts_loop', send, ())

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# CMD
	func.unServerCMD('sam_adverts_delay')
	func.unServerCMD('sam_adverts_on_console')
	func.unServerCMD('sam_adverts_tag')

	# CANCEL DELAY
	gamethread.cancelDelayed('sam_adverts_loop')

# =============================================================================== #
# === <<<> FUNCTIONS <>>> ======================================================= #
# =============================================================================== #
def send():
	list = getAds()
	if len(list):
		if len(list) > 1 and temp['last'] in list: list.remove(temp['last'])
		temp['last'] = str(random.choice(list))
		if temp['tag']: func.tell('#all', temp['last'],False,temp['logmsgs'])
		else: func.say('#all', temp['last'], temp['logmsgs'])
	gamethread.delayedname(temp['delay'], 'sam_adverts_loop', send, ())

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def getAds():
	list = []
	if os.path.isfile(path):
		with open(path) as f:
			for x in [line.strip('-').strip(' ').strip('\n') for line in f.readlines() if line.startswith('-')]: list.append(x)
	for x in monitor.msgs:
		x     = x.split('_')
		addon = x[0]
		x.remove(addon)
		list.append(func.langAddon(addon, '_'.join(x)))
	return list

# =============================================================================== #
# === <<<> CMD BLOCKS <>>> ====================================================== #
# =============================================================================== #
def delayCMD(args):
	if args:
		args = ' '.join(args)
		if args.isdigit(): temp['delay'] = int(args)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def logCMD(args):
	if args:
		try:
			args = int(' '.join(args))
			if args in (1,0): temp['logmsgs'] = bool(args)
		except: pass

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def tagCMD(args):
	if args:
		try:
			args = int(' '.join(args))
			if args in (1,0): temp['tag'] = bool(args)
		except: pass

# =============================================================================== #
# === <<<> FILTERS AND OTHERS <>>> ============================================== #
# =============================================================================== #
def createFile():
	if not os.path.isfile(path):
		f = open(path,'w')
		f.write('# - - - - - - - - - - - - - - - - - #\n')
		f.write('#  Source Admin Menu # Adverts file #\n')
		f.write('# - - - - - - - - - - - - - - - - - #\n')
		f.write('#\n')
		f.write('#  # How to add an advert?\n')
		f.write('#  - Start a new line with -, and write whatever you want.\n')
		f.write('#  - Use colors to colorize your messages.\n')
		f.write('#\n')
		f.write('#  COLORS:\n')
		f.write('#  #red, #green, #blue, #pink, #yellow, purple, #cyan, #beige, #grey\n')
		f.write('#  #white, #black, dimgrey, #ct, #t, #spec, #default, #lightgreen\n \n')
		f.write('- #greenWelcome to our server, have fun with us!\n')
		f.write('- #greyThis server is running #purpleSAM v5.0#grey, powered by #ctEventScripts by Mattie#grey.\n')
		f.write('- #beigeType #t!admins #beigein the chat to know the #cyanAdmins Online#beige.\n')
		f.write('- #beigeType #t!spec #beigeto easily join #specSpectators#beige.\n')
		f.write('- #greenLike the server? Add it to your favorites.\n')
		f.write('- #greenCheating is totally forbidden!\n')
		f.write('- #greenRespect to be respected!\n')
		f.close()

# =============================================================================== #